// ----------------------------------------------------------------------------
//
// PneuBeaZMain.PAS                                      Ulrich Mller 28.12.99
//                                                       Procida 400NT  Delphi4
// Pneumatisches Bearbeitungszentrum :
//   Delphi4 Adaption des LLWin Programms Bearbeit.MDL der Pneumatic Robots
//
// Zyklus : Teil zufhren/auswerfen, Schieber zurck,
//          Drehtisch weiter, Teil stempeln.
//
// Der jeweilige Status wird auf der Form angezeigt (lblStatus)
//
// Nutzung umFish.DLL, ggf. PortNamen anpassen
//
// ----------------------------------------------------------------------------

unit PneuBeaZMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfrmBeaZMain = class(TForm)
    cmdStart: TButton;
    cmdHalt: TButton;
    cmdEnde: TButton;
    lblTitel: TLabel;
    lblCopyright: TLabel;
    lblStatus: TLabel;
    procedure cmdEndeClick(Sender: TObject);
    procedure cmdHaltClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmdStartClick(Sender: TObject);
  private
    procedure BeaZMain();
    procedure DrehTisch();
    procedure Presse();
    procedure SchieberRueck();
    procedure SchieberVor();
  public
    { Public-Deklarationen}
  end;

  var
     frmBeaZMain: TfrmBeaZMain;

implementation

{$R *.DFM}

uses umFish;

const
     cvSchieVor = 1; cvSchieZuruck = 2; cvStempel = 3;   // --- Magnetventile
     cmTisch = 4;                                        // --- Motor
     ctTisch = 1;                                        // --- Taster
var
  FishFace: TftiDCB; pFishFace: TpftiDCB;

procedure TfrmBeaZMain.cmdEndeClick(Sender: TObject);
begin
     close;
end;

procedure TfrmBeaZMain.cmdHaltClick(Sender: TObject);
// --- Setzen NotHalt, um Ende einzuleiten ----------
begin
     cmdStart.SetFocus;
     NotHalt := true;
end;

procedure TfrmBeaZMain.FormCreate(Sender: TObject);
begin
     pFishFace := @FishFace;
     NotHalt := true;
end;

procedure TfrmBeaZMain.cmdStartClick(Sender: TObject);
// --------- Starten der SortSteuerung ----------------
begin
     cmdHalt.SetFocus;
     if NotHalt then              // --- Ist beim Programmstart true
     begin
          NotHalt := false;
          if OpenInterface(pFishFace, 'COM1') = ftiFehler then
          begin
            MessageDlg('InterfaceProblem', mtInformation,[mbOK], 0);
            exit;
          end;                                    { ggf COMx anpassen }
          BeaZMain;               // --- Teile Stempeln
          ClearMotors(pFishFace);  // --- Ende
          cmdStart.SetFocus;
          lblStatus.Caption := 'START/ENDE';
          CloseInterface(pFishFace);
     end;
end;

procedure TfrmBeaZMain.BeaZMain;
// --- Hauptprogramm, Schleife, die ber NotHalt beendet wird ---
begin
  DrehTisch;
  SchieberRueck;
  lblStatus.Caption := 'Anlage ready';
  Application.ProcessMessages;

  repeat
    SchieberVor;
    SchieberRueck;
    DrehTisch;
    Presse;
    Presse;
  until NotHalt;
end;

procedure TfrmBeaZMain.DrehTisch;
// --- DrehTisch um eine Position weiterschalten ---
begin
  SetMotor(pFishFace, cmTisch, ftiLinks);
  lblStatus.Caption := 'Drehen';
  WaitForInput(pFishFace, ctTisch, false);     // --- TischTaster frei
  WaitForInput(pFishFace, ctTisch);            //     nchste Position
  SetMotor(pFishFace, cmTisch, ftiAus);
  WaitForTime(pFishFace, 1000);
end;

procedure TfrmBeaZMain.Presse;
// --- Teil stempeln ---------
begin
  SetMotor(pFishFace, cvStempel, ftiEin);
  lblStatus.Caption := 'dong!!!';
  Beep;
  Beep;
  Beep;
  WaitForTime(pFishFace, 1000);
  SetMotor(pFishFace, cvStempel, ftiAus);
  WaitForTime(pFishFace, 1000);
end;

procedure TfrmBeaZMain.SchieberRueck;
// --- Beide Schieber Rckstellen ---
begin
  SetMotor(pFishFace, cvSchieVor, ftiAus);
  SetMotor(pFishFace, cvSchieZuruck, ftiEin);
  lblStatus.Caption := 'Schieber zurck';
  WaitForTime(pFishFace, 1000);
  SetMotor(pFishFace, cvSchieZuruck, ftiAus);
end;

procedure TfrmBeaZMain.SchieberVor;
// --- Beide Schieber vor ---------
begin
  SetMotor(pFishFace, cvSchieZuruck, ftiAus);
  SetMotor(pFishFace, cvSchieVor, ftiEin);
  lblStatus.Caption := 'Schieber vor';
  WaitForTime(pFishFace, 2000);
  SetMotor(pFishFace, cvSchieVor, ftiAus);
end;

end.
